process coSimClu =
     ( ? real a; 
         real b; 
         real c;
       ! real x1; 
         real x2; 
         boolean error; 
         integer lat; 
         integer MaxLat;
     )
   pragmas 
      DefinedClockHierarchy
   end pragmas
   (| (| DateGenerator{}
       | (| d_deb := d_c
          | Latency{}
          |) where HomoType d_deb; end
       | MaxLatency{}
       | P_COSTP{}
       |)/ d_stable, d_error, d_x1, d_x2, next_stable, stable, dEnd, d_c, d_b, d_a |)
   where 
   use Cost_Context, ARCHI_COST, COSTBIB, M_P_COST; 
   process P_COSTP =
        ( ? real a; 
            real b; 
            real c; 
            HomoType d_a; 
            HomoType d_b; 
            HomoType d_c;
          ! real x2; 
            real x1; 
            boolean error; 
            boolean stable init true; 
            boolean next_stable; 
            HomoType d_x2; 
            HomoType d_x1; 
            HomoType d_error; 
            HomoType d_stable;
        )
      (| (| P_Simu{}
          | P_COST{}
          |)/ L421_error, L415_L34_err_1, L406_x_subexpr, L397_d, L388_CLK_84, OK |)
      where 
      process P_Simu =
           ( ? real a, b, c;
             ! real x2, x1; 
               boolean error, stable, OK, next_stable, L388_CLK_84, L397_d, L406_x_subexpr, L415_L34_err_1, L421_error;
           )
         pragmas 
            Main
            DefinedClockHierarchy
         end pragmas
         (| [:Tick] ^= stable ^= next_stable ^= Tick ^= L388_CLK_84
          | [:stable] ^= a ^= b ^= c ^= OK
          | [:OK] ^= L397_d ^= L406_x_subexpr ^= L415_L34_err_1
          | [/:OK] ^= L421_error
          | [:C_err] ^= error
          | L455_nlabel :: equationSolving_250{}
          | L455_nlabel ^= [:stable]
          | [:L391_bb] ^= x2
          | [:C_x1] ^= x1
          | L453_nlabel :: equationSolving_244{}
          | L453_nlabel ^= [:Tick]
          | L454_nlabel :: equationSolving_247{}
          | L454_nlabel ^= [:Tick]
          | L456_nlabel :: equationSolving_253{}
          | L456_nlabel ^= [:Tick]
          | L457_nlabel :: equationSolving_256{}
          | L457_nlabel ^= [:Tick]
          | Tick := true when Tick
          | (| L457_nlabel --> a
             | L457_nlabel --> b
             | L457_nlabel --> c
             | L457_nlabel --> L453_nlabel
             | L457_nlabel --> L454_nlabel
             | L457_nlabel --> L456_nlabel
             | L456_nlabel --> L453_nlabel
             | L455_nlabel --> L453_nlabel
             | L454_nlabel --> L453_nlabel
             | L454_nlabel --> L455_nlabel
             | L454_nlabel --> L456_nlabel
             |)
          |)
         where 
         constant real cst_epsilon = 0.00001; 
         event Tick; 
         boolean biterate, err2, L279_err, L391_bb, L395_extended_OK, L403_extended_d, L412_extended_x_subexpr, L418_extended_L34_err_1, L424_extended_error, L431_extended_, C_err, C_b_cell, C_x, C_x1, C_CLK_295, C_CLK_297; 
         real x, cc, bb, d, dd, aa, L102_bb_subexpr, L106_cc_subexpr, L114_x, L116_x_subexpr, L140_bb, y, next_yy, yy, mx, L168_next_yy_pre, L179_next_stable_subexpr, s, L201_b_cell, L205_x, L214_x, x21, L255_cc, L256_bb, L273_bb, L274_cc; 
         process equationSolving_250 =
              ( ? real c; 
                  boolean stable, OK; 
                  real aa;
                ! real cc, L274_cc;
              )
            pragmas 
               Cluster {a,c}
            end pragmas
            (| cc := L106_cc_subexpr/aa
             | L106_cc_subexpr := c when OK
             | L274_cc := c when (not OK)
             |)
         ; 
         process equationSolving_244 =
              ( ? boolean stable, OK; 
                  real cc, bb, L168_next_yy_pre, L256_bb, L273_bb, L274_cc; 
                  boolean L395_extended_OK, L421_error, L424_extended_error, L431_extended_;
                ! real x2, x1; 
                  boolean error; 
                  real next_yy; 
                  boolean next_stable;
              )
            pragmas 
               Cluster {a,b,c}
            end pragmas
            (| x2 := L205_x
             | x1 := x21 default (x when C_CLK_295)
             | error := L279_err
             | x := -(L255_cc/L256_bb)
             | d := dd when L397_d
             | dd := (bb*bb)-(4.0*cc)
             | L114_x := (-L116_x_subexpr)/2.0
             | L116_x_subexpr := bb when L406_x_subexpr
             | L140_bb := L201_b_cell when L391_bb
             | y := yy when L391_bb
             | biterate := (true when L397_d) default ((not stable) when (not L403_extended_d))
             | next_yy := (((yy+(mx/yy))/2.0) when biterate) default (yy when (not biterate))
             | yy := (d/2.0) default (L168_next_yy_pre when (not L403_extended_d))
             | mx := d cell Tick init 0.0e0
             | next_stable := s<cst_epsilon
             | L179_next_stable_subexpr := next_yy-yy
             | s := (L179_next_stable_subexpr when L388_CLK_84) default ((-L179_next_stable_subexpr) when (not L388_CLK_84))
             | L201_b_cell := bb cell C_b_cell init 0.0e0
             | L205_x := -((L140_bb-y)/2.0)
             | L214_x := -((L140_bb+y)/2.0)
             | x21 := L214_x default (L114_x when C_CLK_297)
             | L255_cc := L274_cc when (not L421_error)
             | err2 := (L274_cc/=0.0) when L421_error
             | L279_err := (true when L415_L34_err_1) default err2
             | L388_CLK_84 := L179_next_stable_subexpr>=0.0
             | L391_bb := next_stable and biterate
             | L397_d := dd>0.0
             | L403_extended_d := left_tt(L397_d, stable)
             | L406_x_subexpr := dd=0.0
             | L412_extended_x_subexpr := left_tt(L406_x_subexpr, stable)
             | L415_L34_err_1 := dd<0.0
             | L418_extended_L34_err_1 := left_tt(L415_L34_err_1, OK)
             | C_err := L418_extended_L34_err_1 or L424_extended_error
             | C_b_cell := L391_bb or L395_extended_OK
             | C_x := L391_bb or L412_extended_x_subexpr
             | C_x1 := C_x or L431_extended_
             | C_CLK_295 := (not C_x) and L431_extended_
             | C_CLK_297 := (not L391_bb) and L412_extended_x_subexpr
             |)
         ; 
         process equationSolving_247 =
              ( ? real a; 
                  boolean stable;
                ! boolean OK; 
                  real aa; 
                  boolean L395_extended_OK;
              )
            pragmas 
               Cluster {a}
            end pragmas
            (| OK := a/=0.0
             | aa := a when OK
             | L395_extended_OK := left_tt(OK, stable)
             |)
         ; 
         process equationSolving_253 =
              ( ? real b; 
                  boolean stable, OK; 
                  real aa;
                ! real bb, L256_bb, L273_bb; 
                  boolean L421_error, L424_extended_error, L431_extended_;
              )
            pragmas 
               Cluster {a,b}
            end pragmas
            (| bb := L102_bb_subexpr/aa
             | L102_bb_subexpr := b when OK
             | L256_bb := L273_bb when (not L421_error)
             | L273_bb := b when (not OK)
             | L421_error := L273_bb=0.0
             | L424_extended_error := left_tt(L421_error, not OK)
             | L431_extended_ := left_tt(not L421_error, stable)
             |)
         ; 
         process equationSolving_256 =
              ( ? real next_yy; 
                  boolean next_stable;
                ! boolean stable; 
                  real L168_next_yy_pre;
              )
            pragmas 
               Cluster
            end pragmas
            (| stable := next_stable$1 init true
             | L168_next_yy_pre := next_yy$1 init 1.0
             |)
         ; 
         label L453_nlabel, L454_nlabel, L455_nlabel, L456_nlabel, L457_nlabel;
         end
      ; 
      boolean OK, L388_CLK_84, L397_d, L406_x_subexpr, L415_L34_err_1, L421_error;
      end
   ; 
   process DateGenerator =
        ( ? dEnd;
          ! d_a; 
            HomoType d_b; 
            HomoType d_c;
        )
      (| d := ((dEnd$ init NilHomoTypeValue) when (^d_a))+(d$ init NilHomoTypeValue)
       | d_a := d
       | d_b := d
       | d_c := d
       |)
      where 
      HomoType d;
      end
   ; 
   process Latency =
        ( ? d_deb; 
            boolean stable; 
            HomoType d_x1; 
            HomoType d_x2; 
            HomoType d_error;
          ! HomoType dEnd; 
            HomoType lat;
        )
      (| d_end := MAX(MAX(d_x1, d_x2), d_error)
       | dEnd := d_end cell (^stable)
       | l := dEnd-(d_deb cell (^stable))
       | lat := l when (^d_end)
       |)
      where 
      HomoType l, d_end; 
      process MAX =
           ( ? HomoType IN1; 
               HomoType IN2;
             ! HomoType MAX_VAL;
           )
         (| HCOMMON := [:^IN1] when (^IN2)
          | c1 := IN1 when HCOMMON
          | c2 := IN2 when HCOMMON
          | MAX_VAL := (IN1 when (c1>c2)) default IN2 default IN1
          |)
         where 
         event HCOMMON; 
         HomoType c1, c2;
         end
      ;
      end
   ; 
   process MaxLatency =
        ( ? HomoType lat;
          ! HomoType MaxLat;
        )
      (| MaxLat := (lat when (lat>ZMaxLat)) default ZMaxLat
       | ZMaxLat := MaxLat$1 init NilHomoTypeValue
       | ZMaxLat ^= lat
       |)
      where 
      HomoType ZMaxLat;
      end
   ; 
   HomoType d_a, d_b, d_c, dEnd, d_x2, d_x1, d_error, d_stable; 
   boolean stable init true, next_stable;
   end
; 
