process coSim =
     ( ? real a; 
         real b; 
         real c;
       ! real x1; 
         real x2; 
         boolean error; 
         integer lat; 
         integer MaxLat;
     )
  %  pragmas 
      DefinedClockHierarchy
   end pragmas %
   (| (| DateGenerator{}
       | (| d_deb := d_c
          | Latency{}
          |) where HomoType d_deb; end
       | MaxLatency{}
       | P_COSTP{}
       |)/ d_stable, d_x2, d_x1, d_error, stable, next_stable, dEnd, d_c, d_b, d_a |)
   where 
   use Cost_Context, ARCHI_COST, COSTBIB, M_P_COST; 
   boolean next_stable, stable; 
   process P_COSTP =
        ( ? real a; 
            real b; 
            real c; 
            HomoType d_a; 
            HomoType d_b; 
            HomoType d_c;
          ! real x2; 
            real x1; 
            boolean error; 
            boolean stable init true; 
            boolean next_stable; 
            d_x2; 
            d_x1; 
            d_error; 
            HomoType d_stable;
        )
      (| (| P_COST{}
          | P_SIMU{}
          |)/ L421_error, L415_L34_err_1, L406_x_subexpr, L397_d, L388_CLK_84, OK |)
      where 
      constant real cst_epsilon = 0.0001; 
      process P_SIMU =
           ( ? real a, b, c;
             ! real x2, x1; 
               boolean error, stable, OK, next_stable, L388_CLK_84, L397_d, L406_x_subexpr, L415_L34_err_1, L421_error;
           )
        %  pragmas 
            Main
            DefinedClockHierarchy
         end pragmas %
         (| (| [:Tick] ^= stable ^= next_stable ^= Tick ^= L388_CLK_84
             | SUBTREE_of_Tick{}
             |) |)
         where 
         constant real cst_epsilon = 0.00001; 
         event Tick; 
         process SUBTREE_of_Tick =
              ( ? real a, b, c;
                ! event Tick;
              )
            (| [:Tick] ^= biterate ^= next_yy ^= yy ^= mx ^= L168_next_yy_pre ^= L179_next_stable_subexpr ^= s ^= L391_bb ^= L395_extended_OK ^= L403_extended_d ^= L412_extended_x_subexpr ^= L431_extended_ ^= C_b_cell ^= C_x ^= C_x1 ^= C_CLK_295 ^= 
               C_CLK_297
             | (| [:stable] ^= a ^= b ^= c ^= OK
                | SUBTREE_of_stable{}
                |)
             | (| [:L391_bb] ^= x2 ^= L214_x
                | SUBTREE_of_L391_bb{}
                |)
             | (| [:C_b_cell] ^= L201_b_cell
                | SUBTREE_of_C_b_cell{}
                |)
             | (| [:C_x] ^= x21
                | SUBTREE_of_C_x{}
                |)
             | (| [:C_x1] ^= x1
                | SUBTREE_of_C_x1{}
                |)
             | (| stable := next_stable$1 init true
                | biterate := (true when L397_d) default ((not stable) when (not L403_extended_d))
                | next_yy := (((yy+(mx/yy))/2.0) when biterate) default (yy when (not biterate))
                | yy := (d/2.0) default (L168_next_yy_pre when (not L403_extended_d))
                | mx := d cell Tick init 0.0e0
                | L168_next_yy_pre := next_yy$1 init 1.0
                | next_stable := s<cst_epsilon
                | L179_next_stable_subexpr := next_yy-yy
                | s := (L179_next_stable_subexpr when L388_CLK_84) default ((-L179_next_stable_subexpr) when (not L388_CLK_84))
                | Tick := true when Tick
                | L388_CLK_84 := L179_next_stable_subexpr>=0.0
                | L391_bb := next_stable and biterate
                | L395_extended_OK := left_tt(OK, stable)
                | L403_extended_d := left_tt(L397_d, stable)
                | L412_extended_x_subexpr := left_tt(L406_x_subexpr, stable)
                | L431_extended_ := left_tt(not L421_error, stable)
                | C_b_cell := L391_bb or L395_extended_OK
                | C_x := L391_bb or L412_extended_x_subexpr
                | C_x1 := C_x or L431_extended_
                | C_CLK_295 := (not C_x) and L431_extended_
                | C_CLK_297 := (not L391_bb) and L412_extended_x_subexpr
                |)
             |)
            where 
            boolean biterate, L391_bb, L395_extended_OK, L403_extended_d, L412_extended_x_subexpr, L431_extended_, C_b_cell, C_x, C_x1, C_CLK_295, C_CLK_297; 
            real x, cc, bb, d, L114_x, next_yy, yy, mx, L168_next_yy_pre, L179_next_stable_subexpr, s, L201_b_cell, L214_x, x21; 
            process SUBTREE_of_stable =
                 ( ? real a, b, c; 
                     boolean stable;
                   ! real x, bb, d, L114_x;
                 )
               (| [:stable] ^= L418_extended_L34_err_1 ^= L424_extended_error ^= C_err
                | (| [:OK] ^= bb ^= dd ^= L397_d ^= L406_x_subexpr ^= L415_L34_err_1
                   | SUBTREE_of_OK{}
                   | [/:OK] ^= L273_bb ^= L421_error
                   | SUBTREE_of_L273_bb{}
                   |)
                | (| [:C_err] ^= error
                   | SUBTREE_of_C_err{}
                   |)
                | (| OK := a/=0.0
                   | L418_extended_L34_err_1 := left_tt(L415_L34_err_1, OK)
                   | L424_extended_error := left_tt(L421_error, not OK)
                   | C_err := L418_extended_L34_err_1 or L424_extended_error
                   |)
                |)
               where 
               boolean err2, L418_extended_L34_err_1, L424_extended_error, C_err; 
               real cc, dd, L273_bb; 
               process SUBTREE_of_OK =
                    ( ? real a, b, c; 
                        boolean OK;
                      ! real bb, d, dd, L114_x;
                    )
                  (| [:OK] ^= cc ^= aa ^= L102_bb_subexpr ^= L106_cc_subexpr
                   | (| [:L397_d] ^= d
                      | SUBTREE_of_L397_d{}
                      |)
                   | (| [:L406_x_subexpr] ^= L114_x
                      | SUBTREE_of_L406_x_subexpr{}
                      |)
                   | (| cc := L106_cc_subexpr/aa
                      | bb := L102_bb_subexpr/aa
                      | dd := (bb*bb)-(4.0*cc)
                      | aa := a when OK
                      | L102_bb_subexpr := b when OK
                      | L106_cc_subexpr := c when OK
                      | L397_d := dd>0.0
                      | L406_x_subexpr := dd=0.0
                      | L415_L34_err_1 := dd<0.0
                      |)
                   |)
                  where 
                  real cc, aa, L102_bb_subexpr, L106_cc_subexpr; 
                  process SUBTREE_of_L397_d =
                       ( ? real dd; 
                           boolean L397_d;
                         ! real d;
                       )
                     (| (| d := dd when L397_d |) |)
                  ; 
                  process SUBTREE_of_L406_x_subexpr =
                       ( ? real bb; 
                           boolean L406_x_subexpr;
                         ! real L114_x;
                       )
                     (| [:L406_x_subexpr] ^= L116_x_subexpr
                      | (| L114_x := (-L116_x_subexpr)/2.0
                         | L116_x_subexpr := bb when L406_x_subexpr
                         |)
                      |)
                     where 
                     real L116_x_subexpr;
                     end
                  ;
                  end
               ; 
               process SUBTREE_of_L273_bb =
                    ( ? real b, c; 
                        boolean OK;
                      ! real x; 
                        boolean err2; 
                        real L273_bb;
                    )
                  (| [/:OK] ^= L274_cc
                   | (| [:L421_error] ^= err2
                      | SUBTREE_of_L421_error{}
                      |)
                   | (| [/:L421_error] ^= x
                      | SUBTREE_of_x{}
                      |)
                   | (| L273_bb := b when (not OK)
                      | L274_cc := c when (not OK)
                      | L421_error := L273_bb=0.0
                      |)
                   |)
                  where 
                  real L274_cc; 
                  process SUBTREE_of_L421_error =
                       ( ? real L274_cc; 
                           boolean L421_error;
                         ! boolean err2;
                       )
                     (| (| err2 := (L274_cc/=0.0) when L421_error |) |)
                  ; 
                  process SUBTREE_of_x =
                       ( ? real L273_bb, L274_cc; 
                           boolean L421_error;
                         ! real x;
                       )
                     (| [/:L421_error] ^= L255_cc ^= L256_bb
                      | (| x := -(L255_cc/L256_bb)
                         | L255_cc := L274_cc when (not L421_error)
                         | L256_bb := L273_bb when (not L421_error)
                         |)
                      |)
                     where 
                     real L255_cc, L256_bb;
                     end
                  ;
                  end
               ; 
               process SUBTREE_of_C_err =
                    ( ? real dd; 
                        boolean err2; 
                        real L273_bb; 
                        boolean C_err;
                    )
                  (| [:C_err] ^= L279_err
                   | (| error := L279_err
                      | L279_err := (true when L415_L34_err_1) default err2
                      |)
                   |)
                  where 
                  boolean L279_err;
                  end
               ;
               end
            ; 
            process SUBTREE_of_L391_bb =
                 ( ? real yy, L201_b_cell; 
                     boolean L391_bb;
                   ! real L214_x;
                 )
               (| [:L391_bb] ^= L140_bb ^= y ^= L205_x
                | (| x2 := L205_x
                   | L140_bb := L201_b_cell when L391_bb
                   | y := yy when L391_bb
                   | L205_x := -((L140_bb-y)/2.0)
                   | L214_x := -((L140_bb+y)/2.0)
                   |)
                |)
               where 
               real L140_bb, y, L205_x;
               end
            ; 
            process SUBTREE_of_C_b_cell =
                 ( ? boolean OK; 
                     real bb; 
                     boolean C_b_cell;
                   ! real L201_b_cell;
                 )
               (| (| L201_b_cell := bb cell C_b_cell init 0.0e0 |) |)
            ; 
            process SUBTREE_of_C_x =
                 ( ? real L114_x, L214_x; 
                     boolean L391_bb, C_x, C_CLK_297;
                   ! real x21;
                 )
               (| (| x21 := L214_x default (L114_x when C_CLK_297) |) |)
            ; 
            process SUBTREE_of_C_x1 =
                 ( ? real x, x21; 
                     boolean C_x, C_x1, C_CLK_295;
                 )
               (| (| x1 := x21 default (x when C_CLK_295) |) |)
            ;
            end
         ;
         end
      ; 
      boolean OK, L388_CLK_84, L397_d, L406_x_subexpr, L415_L34_err_1, L421_error;
      end
   ; 
   process DateGenerator =
        ( ? dEnd;
          ! d_a; 
            HomoType d_b; 
            HomoType d_c;
        )
      (| d := ((dEnd$ init NilHomoTypeValue) when (^d_a))+(d$ init NilHomoTypeValue)
       | d_a := d
       | d_b := d
       | d_c := d
       |)
      where 
      HomoType d;
      end
   ; 
   process MaxLatency =
        ( ? HomoType lat;
          ! HomoType MaxLat;
        )
      (| MaxLat := (lat when (lat>ZMaxLat)) default ZMaxLat
       | ZMaxLat := MaxLat$1 init NilHomoTypeValue
       | ZMaxLat ^= lat
       |)
      where 
      HomoType ZMaxLat;
      end
   ; 
   process Latency =
        ( ? d_deb; 
            boolean stable; 
            HomoType d_x1; 
            HomoType d_x2; 
            HomoType d_error;
          ! HomoType dEnd; 
            HomoType lat;
        )
      (| d_end := MAX(MAX(d_x1, d_x2), d_error)
       | dEnd := d_end cell (^stable)
       | l := dEnd-(d_deb cell (^stable))
       | lat := l when (^d_end)
       |)
      where 
      HomoType l, d_end; 
      process MAX =
           ( ? HomoType IN1; 
               HomoType IN2;
             ! HomoType MAX_VAL;
           )
         (| HCOMMON := [:^IN1] when (^IN2)
          | c1 := IN1 when HCOMMON
          | c2 := IN2 when HCOMMON
          | MAX_VAL := (IN1 when (c1>c2)) default IN2 default IN1
          |)
         where 
         event HCOMMON; 
         HomoType c1, c2;
         end
      ;
      end
   ; 
   HomoType d_a, d_b, d_c, dEnd, d_error, d_x1, d_x2, d_stable;
   end
; 
